commit-graph: use generation v2 only if entire chain does
[git] / t / test-lib-functions.sh
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
3 #
4 # Copyright (c) 2005 Junio C Hamano
5 #
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
21 #
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
25 #
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29         FAKE_EDITOR="$1"
30         export FAKE_EDITOR
31         EDITOR='"$FAKE_EDITOR"'
32         export EDITOR
33 }
34
35 test_set_index_version () {
36     GIT_INDEX_VERSION="$1"
37     export GIT_INDEX_VERSION
38 }
39
40 test_decode_color () {
41         awk '
42                 function name(n) {
43                         if (n == 0) return "RESET";
44                         if (n == 1) return "BOLD";
45                         if (n == 2) return "FAINT";
46                         if (n == 3) return "ITALIC";
47                         if (n == 7) return "REVERSE";
48                         if (n == 30) return "BLACK";
49                         if (n == 31) return "RED";
50                         if (n == 32) return "GREEN";
51                         if (n == 33) return "YELLOW";
52                         if (n == 34) return "BLUE";
53                         if (n == 35) return "MAGENTA";
54                         if (n == 36) return "CYAN";
55                         if (n == 37) return "WHITE";
56                         if (n == 40) return "BLACK";
57                         if (n == 41) return "BRED";
58                         if (n == 42) return "BGREEN";
59                         if (n == 43) return "BYELLOW";
60                         if (n == 44) return "BBLUE";
61                         if (n == 45) return "BMAGENTA";
62                         if (n == 46) return "BCYAN";
63                         if (n == 47) return "BWHITE";
64                 }
65                 {
66                         while (match($0, /\033\[[0-9;]*m/) != 0) {
67                                 printf "%s<", substr($0, 1, RSTART-1);
68                                 codes = substr($0, RSTART+2, RLENGTH-3);
69                                 if (length(codes) == 0)
70                                         printf "%s", name(0)
71                                 else {
72                                         n = split(codes, ary, ";");
73                                         sep = "";
74                                         for (i = 1; i <= n; i++) {
75                                                 printf "%s%s", sep, name(ary[i]);
76                                                 sep = ";"
77                                         }
78                                 }
79                                 printf ">";
80                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
81                         }
82                         print
83                 }
84         '
85 }
86
87 lf_to_nul () {
88         perl -pe 'y/\012/\000/'
89 }
90
91 nul_to_q () {
92         perl -pe 'y/\000/Q/'
93 }
94
95 q_to_nul () {
96         perl -pe 'y/Q/\000/'
97 }
98
99 q_to_cr () {
100         tr Q '\015'
101 }
102
103 q_to_tab () {
104         tr Q '\011'
105 }
106
107 qz_to_tab_space () {
108         tr QZ '\011\040'
109 }
110
111 append_cr () {
112         sed -e 's/$/Q/' | tr Q '\015'
113 }
114
115 remove_cr () {
116         tr '\015' Q | sed -e 's/Q$//'
117 }
118
119 # Generate an output of $1 bytes of all zeroes (NULs, not ASCII zeroes).
120 # If $1 is 'infinity', output forever or until the receiving pipe stops reading,
121 # whichever comes first.
122 generate_zero_bytes () {
123         test-tool genzeros "$@"
124 }
125
126 # In some bourne shell implementations, the "unset" builtin returns
127 # nonzero status when a variable to be unset was not set in the first
128 # place.
129 #
130 # Use sane_unset when that should not be considered an error.
131
132 sane_unset () {
133         unset "$@"
134         return 0
135 }
136
137 test_tick () {
138         if test -z "${test_tick+set}"
139         then
140                 test_tick=1112911993
141         else
142                 test_tick=$(($test_tick + 60))
143         fi
144         GIT_COMMITTER_DATE="$test_tick -0700"
145         GIT_AUTHOR_DATE="$test_tick -0700"
146         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
147 }
148
149 # Stop execution and start a shell. This is useful for debugging tests.
150 #
151 # Be sure to remove all invocations of this command before submitting.
152
153 test_pause () {
154         "$SHELL_PATH" <&6 >&5 2>&7
155 }
156
157 # Wrap git with a debugger. Adding this to a command can make it easier
158 # to understand what is going on in a failing test.
159 #
160 # Examples:
161 #     debug git checkout master
162 #     debug --debugger=nemiver git $ARGS
163 #     debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
164 debug () {
165         case "$1" in
166         -d)
167                 GIT_DEBUGGER="$2" &&
168                 shift 2
169                 ;;
170         --debugger=*)
171                 GIT_DEBUGGER="${1#*=}" &&
172                 shift 1
173                 ;;
174         *)
175                 GIT_DEBUGGER=1
176                 ;;
177         esac &&
178         GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
179 }
180
181 # Call test_commit with the arguments
182 # [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
183 #
184 # This will commit a file with the given contents and the given commit
185 # message, and tag the resulting commit with the given tag name.
186 #
187 # <file>, <contents>, and <tag> all default to <message>.
188 #
189 # If the first argument is "-C", the second argument is used as a path for
190 # the git invocations.
191
192 test_commit () {
193         notick= &&
194         signoff= &&
195         indir= &&
196         while test $# != 0
197         do
198                 case "$1" in
199                 --notick)
200                         notick=yes
201                         ;;
202                 --signoff)
203                         signoff="$1"
204                         ;;
205                 --date)
206                         notick=yes
207                         GIT_COMMITTER_DATE="$2"
208                         GIT_AUTHOR_DATE="$2"
209                         shift
210                         ;;
211                 -C)
212                         indir="$2"
213                         shift
214                         ;;
215                 *)
216                         break
217                         ;;
218                 esac
219                 shift
220         done &&
221         indir=${indir:+"$indir"/} &&
222         file=${2:-"$1.t"} &&
223         echo "${3-$1}" > "$indir$file" &&
224         git ${indir:+ -C "$indir"} add "$file" &&
225         if test -z "$notick"
226         then
227                 test_tick
228         fi &&
229         git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
230         git ${indir:+ -C "$indir"} tag "${4:-$1}"
231 }
232
233 # Call test_merge with the arguments "<message> <commit>", where <commit>
234 # can be a tag pointing to the commit-to-merge.
235
236 test_merge () {
237         label="$1" &&
238         shift &&
239         test_tick &&
240         git merge -m "$label" "$@" &&
241         git tag "$label"
242 }
243
244 # Efficiently create <nr> commits, each with a unique number (from 1 to <nr>
245 # by default) in the commit message.
246 #
247 # Usage: test_commit_bulk [options] <nr>
248 #   -C <dir>:
249 #       Run all git commands in directory <dir>
250 #   --ref=<n>:
251 #       ref on which to create commits (default: HEAD)
252 #   --start=<n>:
253 #       number commit messages from <n> (default: 1)
254 #   --message=<msg>:
255 #       use <msg> as the commit mesasge (default: "commit %s")
256 #   --filename=<fn>:
257 #       modify <fn> in each commit (default: %s.t)
258 #   --contents=<string>:
259 #       place <string> in each file (default: "content %s")
260 #   --id=<string>:
261 #       shorthand to use <string> and %s in message, filename, and contents
262 #
263 # The message, filename, and contents strings are evaluated by printf, with the
264 # first "%s" replaced by the current commit number. So you can do:
265 #
266 #   test_commit_bulk --filename=file --contents="modification %s"
267 #
268 # to have every commit touch the same file, but with unique content.
269 #
270 test_commit_bulk () {
271         tmpfile=.bulk-commit.input
272         indir=.
273         ref=HEAD
274         n=1
275         message='commit %s'
276         filename='%s.t'
277         contents='content %s'
278         while test $# -gt 0
279         do
280                 case "$1" in
281                 -C)
282                         indir=$2
283                         shift
284                         ;;
285                 --ref=*)
286                         ref=${1#--*=}
287                         ;;
288                 --start=*)
289                         n=${1#--*=}
290                         ;;
291                 --message=*)
292                         message=${1#--*=}
293                         ;;
294                 --filename=*)
295                         filename=${1#--*=}
296                         ;;
297                 --contents=*)
298                         contents=${1#--*=}
299                         ;;
300                 --id=*)
301                         message="${1#--*=} %s"
302                         filename="${1#--*=}-%s.t"
303                         contents="${1#--*=} %s"
304                         ;;
305                 -*)
306                         BUG "invalid test_commit_bulk option: $1"
307                         ;;
308                 *)
309                         break
310                         ;;
311                 esac
312                 shift
313         done
314         total=$1
315
316         add_from=
317         if git -C "$indir" rev-parse --quiet --verify "$ref"
318         then
319                 add_from=t
320         fi
321
322         while test "$total" -gt 0
323         do
324                 test_tick &&
325                 echo "commit $ref"
326                 printf 'author %s <%s> %s\n' \
327                         "$GIT_AUTHOR_NAME" \
328                         "$GIT_AUTHOR_EMAIL" \
329                         "$GIT_AUTHOR_DATE"
330                 printf 'committer %s <%s> %s\n' \
331                         "$GIT_COMMITTER_NAME" \
332                         "$GIT_COMMITTER_EMAIL" \
333                         "$GIT_COMMITTER_DATE"
334                 echo "data <<EOF"
335                 printf "$message\n" $n
336                 echo "EOF"
337                 if test -n "$add_from"
338                 then
339                         echo "from $ref^0"
340                         add_from=
341                 fi
342                 printf "M 644 inline $filename\n" $n
343                 echo "data <<EOF"
344                 printf "$contents\n" $n
345                 echo "EOF"
346                 echo
347                 n=$((n + 1))
348                 total=$((total - 1))
349         done >"$tmpfile"
350
351         git -C "$indir" \
352             -c fastimport.unpacklimit=0 \
353             fast-import <"$tmpfile" || return 1
354
355         # This will be left in place on failure, which may aid debugging.
356         rm -f "$tmpfile"
357
358         # If we updated HEAD, then be nice and update the index and working
359         # tree, too.
360         if test "$ref" = "HEAD"
361         then
362                 git -C "$indir" checkout -f HEAD || return 1
363         fi
364
365 }
366
367 # This function helps systems where core.filemode=false is set.
368 # Use it instead of plain 'chmod +x' to set or unset the executable bit
369 # of a file in the working directory and add it to the index.
370
371 test_chmod () {
372         chmod "$@" &&
373         git update-index --add "--chmod=$@"
374 }
375
376 # Get the modebits from a file or directory.
377 test_modebits () {
378         ls -ld "$1" | sed -e 's|^\(..........\).*|\1|'
379 }
380
381 # Unset a configuration variable, but don't fail if it doesn't exist.
382 test_unconfig () {
383         config_dir=
384         if test "$1" = -C
385         then
386                 shift
387                 config_dir=$1
388                 shift
389         fi
390         git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
391         config_status=$?
392         case "$config_status" in
393         5) # ok, nothing to unset
394                 config_status=0
395                 ;;
396         esac
397         return $config_status
398 }
399
400 # Set git config, automatically unsetting it after the test is over.
401 test_config () {
402         config_dir=
403         if test "$1" = -C
404         then
405                 shift
406                 config_dir=$1
407                 shift
408         fi
409         test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
410         git ${config_dir:+-C "$config_dir"} config "$@"
411 }
412
413 test_config_global () {
414         test_when_finished "test_unconfig --global '$1'" &&
415         git config --global "$@"
416 }
417
418 write_script () {
419         {
420                 echo "#!${2-"$SHELL_PATH"}" &&
421                 cat
422         } >"$1" &&
423         chmod +x "$1"
424 }
425
426 # Use test_set_prereq to tell that a particular prerequisite is available.
427 # The prerequisite can later be checked for in two ways:
428 #
429 # - Explicitly using test_have_prereq.
430 #
431 # - Implicitly by specifying the prerequisite tag in the calls to
432 #   test_expect_{success,failure} and test_external{,_without_stderr}.
433 #
434 # The single parameter is the prerequisite tag (a simple word, in all
435 # capital letters by convention).
436
437 test_unset_prereq () {
438         ! test_have_prereq "$1" ||
439         satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
440 }
441
442 test_set_prereq () {
443         if test -n "$GIT_TEST_FAIL_PREREQS_INTERNAL"
444         then
445                 case "$1" in
446                 # The "!" case is handled below with
447                 # test_unset_prereq()
448                 !*)
449                         ;;
450                 # (Temporary?) whitelist of things we can't easily
451                 # pretend not to support
452                 SYMLINKS)
453                         ;;
454                 # Inspecting whether GIT_TEST_FAIL_PREREQS is on
455                 # should be unaffected.
456                 FAIL_PREREQS)
457                         ;;
458                 *)
459                         return
460                 esac
461         fi
462
463         case "$1" in
464         !*)
465                 test_unset_prereq "${1#!}"
466                 ;;
467         *)
468                 satisfied_prereq="$satisfied_prereq$1 "
469                 ;;
470         esac
471 }
472 satisfied_prereq=" "
473 lazily_testable_prereq= lazily_tested_prereq=
474
475 # Usage: test_lazy_prereq PREREQ 'script'
476 test_lazy_prereq () {
477         lazily_testable_prereq="$lazily_testable_prereq$1 "
478         eval test_prereq_lazily_$1=\$2
479 }
480
481 test_run_lazy_prereq_ () {
482         script='
483 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir-'"$1"'" &&
484 (
485         cd "$TRASH_DIRECTORY/prereq-test-dir-'"$1"'" &&'"$2"'
486 )'
487         say >&3 "checking prerequisite: $1"
488         say >&3 "$script"
489         test_eval_ "$script"
490         eval_ret=$?
491         rm -rf "$TRASH_DIRECTORY/prereq-test-dir-$1"
492         if test "$eval_ret" = 0; then
493                 say >&3 "prerequisite $1 ok"
494         else
495                 say >&3 "prerequisite $1 not satisfied"
496         fi
497         return $eval_ret
498 }
499
500 test_have_prereq () {
501         # prerequisites can be concatenated with ','
502         save_IFS=$IFS
503         IFS=,
504         set -- $*
505         IFS=$save_IFS
506
507         total_prereq=0
508         ok_prereq=0
509         missing_prereq=
510
511         for prerequisite
512         do
513                 case "$prerequisite" in
514                 !*)
515                         negative_prereq=t
516                         prerequisite=${prerequisite#!}
517                         ;;
518                 *)
519                         negative_prereq=
520                 esac
521
522                 case " $lazily_tested_prereq " in
523                 *" $prerequisite "*)
524                         ;;
525                 *)
526                         case " $lazily_testable_prereq " in
527                         *" $prerequisite "*)
528                                 eval "script=\$test_prereq_lazily_$prerequisite" &&
529                                 if test_run_lazy_prereq_ "$prerequisite" "$script"
530                                 then
531                                         test_set_prereq $prerequisite
532                                 fi
533                                 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
534                         esac
535                         ;;
536                 esac
537
538                 total_prereq=$(($total_prereq + 1))
539                 case "$satisfied_prereq" in
540                 *" $prerequisite "*)
541                         satisfied_this_prereq=t
542                         ;;
543                 *)
544                         satisfied_this_prereq=
545                 esac
546
547                 case "$satisfied_this_prereq,$negative_prereq" in
548                 t,|,t)
549                         ok_prereq=$(($ok_prereq + 1))
550                         ;;
551                 *)
552                         # Keep a list of missing prerequisites; restore
553                         # the negative marker if necessary.
554                         prerequisite=${negative_prereq:+!}$prerequisite
555                         if test -z "$missing_prereq"
556                         then
557                                 missing_prereq=$prerequisite
558                         else
559                                 missing_prereq="$prerequisite,$missing_prereq"
560                         fi
561                 esac
562         done
563
564         test $total_prereq = $ok_prereq
565 }
566
567 test_declared_prereq () {
568         case ",$test_prereq," in
569         *,$1,*)
570                 return 0
571                 ;;
572         esac
573         return 1
574 }
575
576 test_verify_prereq () {
577         test -z "$test_prereq" ||
578         expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
579         BUG "'$test_prereq' does not look like a prereq"
580 }
581
582 test_expect_failure () {
583         test_start_
584         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
585         test "$#" = 2 ||
586         BUG "not 2 or 3 parameters to test-expect-failure"
587         test_verify_prereq
588         export test_prereq
589         if ! test_skip "$@"
590         then
591                 say >&3 "checking known breakage of $TEST_NUMBER.$test_count '$1': $2"
592                 if test_run_ "$2" expecting_failure
593                 then
594                         test_known_broken_ok_ "$1"
595                 else
596                         test_known_broken_failure_ "$1"
597                 fi
598         fi
599         test_finish_
600 }
601
602 test_expect_success () {
603         test_start_
604         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
605         test "$#" = 2 ||
606         BUG "not 2 or 3 parameters to test-expect-success"
607         test_verify_prereq
608         export test_prereq
609         if ! test_skip "$@"
610         then
611                 say >&3 "expecting success of $TEST_NUMBER.$test_count '$1': $2"
612                 if test_run_ "$2"
613                 then
614                         test_ok_ "$1"
615                 else
616                         test_failure_ "$@"
617                 fi
618         fi
619         test_finish_
620 }
621
622 # test_external runs external test scripts that provide continuous
623 # test output about their progress, and succeeds/fails on
624 # zero/non-zero exit code.  It outputs the test output on stdout even
625 # in non-verbose mode, and announces the external script with "# run
626 # <n>: ..." before running it.  When providing relative paths, keep in
627 # mind that all scripts run in "trash directory".
628 # Usage: test_external description command arguments...
629 # Example: test_external 'Perl API' perl ../path/to/test.pl
630 test_external () {
631         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
632         test "$#" = 3 ||
633         BUG "not 3 or 4 parameters to test_external"
634         descr="$1"
635         shift
636         test_verify_prereq
637         export test_prereq
638         if ! test_skip "$descr" "$@"
639         then
640                 # Announce the script to reduce confusion about the
641                 # test output that follows.
642                 say_color "" "# run $test_count: $descr ($*)"
643                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
644                 # to be able to use them in script
645                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
646                 # Run command; redirect its stderr to &4 as in
647                 # test_run_, but keep its stdout on our stdout even in
648                 # non-verbose mode.
649                 "$@" 2>&4
650                 if test "$?" = 0
651                 then
652                         if test $test_external_has_tap -eq 0; then
653                                 test_ok_ "$descr"
654                         else
655                                 say_color "" "# test_external test $descr was ok"
656                                 test_success=$(($test_success + 1))
657                         fi
658                 else
659                         if test $test_external_has_tap -eq 0; then
660                                 test_failure_ "$descr" "$@"
661                         else
662                                 say_color error "# test_external test $descr failed: $@"
663                                 test_failure=$(($test_failure + 1))
664                         fi
665                 fi
666         fi
667 }
668
669 # Like test_external, but in addition tests that the command generated
670 # no output on stderr.
671 test_external_without_stderr () {
672         # The temporary file has no (and must have no) security
673         # implications.
674         tmp=${TMPDIR:-/tmp}
675         stderr="$tmp/git-external-stderr.$$.tmp"
676         test_external "$@" 4> "$stderr"
677         test -f "$stderr" || error "Internal error: $stderr disappeared."
678         descr="no stderr: $1"
679         shift
680         say >&3 "# expecting no stderr from previous command"
681         if test ! -s "$stderr"
682         then
683                 rm "$stderr"
684
685                 if test $test_external_has_tap -eq 0; then
686                         test_ok_ "$descr"
687                 else
688                         say_color "" "# test_external_without_stderr test $descr was ok"
689                         test_success=$(($test_success + 1))
690                 fi
691         else
692                 if test "$verbose" = t
693                 then
694                         output=$(echo; echo "# Stderr is:"; cat "$stderr")
695                 else
696                         output=
697                 fi
698                 # rm first in case test_failure exits.
699                 rm "$stderr"
700                 if test $test_external_has_tap -eq 0; then
701                         test_failure_ "$descr" "$@" "$output"
702                 else
703                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
704                         test_failure=$(($test_failure + 1))
705                 fi
706         fi
707 }
708
709 # debugging-friendly alternatives to "test [-f|-d|-e]"
710 # The commands test the existence or non-existence of $1. $2 can be
711 # given to provide a more precise diagnosis.
712 test_path_is_file () {
713         if ! test -f "$1"
714         then
715                 echo "File $1 doesn't exist. $2"
716                 false
717         fi
718 }
719
720 test_path_is_dir () {
721         if ! test -d "$1"
722         then
723                 echo "Directory $1 doesn't exist. $2"
724                 false
725         fi
726 }
727
728 test_path_exists () {
729         if ! test -e "$1"
730         then
731                 echo "Path $1 doesn't exist. $2"
732                 false
733         fi
734 }
735
736 # Check if the directory exists and is empty as expected, barf otherwise.
737 test_dir_is_empty () {
738         test_path_is_dir "$1" &&
739         if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
740         then
741                 echo "Directory '$1' is not empty, it contains:"
742                 ls -la "$1"
743                 return 1
744         fi
745 }
746
747 # Check if the file exists and has a size greater than zero
748 test_file_not_empty () {
749         if ! test -s "$1"
750         then
751                 echo "'$1' is not a non-empty file."
752                 false
753         fi
754 }
755
756 test_path_is_missing () {
757         if test -e "$1"
758         then
759                 echo "Path exists:"
760                 ls -ld "$1"
761                 if test $# -ge 1
762                 then
763                         echo "$*"
764                 fi
765                 false
766         fi
767 }
768
769 # test_line_count checks that a file has the number of lines it
770 # ought to. For example:
771 #
772 #       test_expect_success 'produce exactly one line of output' '
773 #               do something >output &&
774 #               test_line_count = 1 output
775 #       '
776 #
777 # is like "test $(wc -l <output) = 1" except that it passes the
778 # output through when the number of lines is wrong.
779
780 test_line_count () {
781         if test $# != 3
782         then
783                 BUG "not 3 parameters to test_line_count"
784         elif ! test $(wc -l <"$3") "$1" "$2"
785         then
786                 echo "test_line_count: line count for $3 !$1 $2"
787                 cat "$3"
788                 return 1
789         fi
790 }
791
792 test_file_size () {
793         test-tool path-utils file-size "$1"
794 }
795
796 # Returns success if a comma separated string of keywords ($1) contains a
797 # given keyword ($2).
798 # Examples:
799 # `list_contains "foo,bar" bar` returns 0
800 # `list_contains "foo" bar` returns 1
801
802 list_contains () {
803         case ",$1," in
804         *,$2,*)
805                 return 0
806                 ;;
807         esac
808         return 1
809 }
810
811 # Returns success if the arguments indicate that a command should be
812 # accepted by test_must_fail(). If the command is run with env, the env
813 # and its corresponding variable settings will be stripped before we
814 # test the command being run.
815 test_must_fail_acceptable () {
816         if test "$1" = "env"
817         then
818                 shift
819                 while test $# -gt 0
820                 do
821                         case "$1" in
822                         *?=*)
823                                 shift
824                                 ;;
825                         *)
826                                 break
827                                 ;;
828                         esac
829                 done
830         fi
831
832         case "$1" in
833         git|__git*|test-tool|test_terminal)
834                 return 0
835                 ;;
836         *)
837                 return 1
838                 ;;
839         esac
840 }
841
842 # This is not among top-level (test_expect_success | test_expect_failure)
843 # but is a prefix that can be used in the test script, like:
844 #
845 #       test_expect_success 'complain and die' '
846 #           do something &&
847 #           do something else &&
848 #           test_must_fail git checkout ../outerspace
849 #       '
850 #
851 # Writing this as "! git checkout ../outerspace" is wrong, because
852 # the failure could be due to a segv.  We want a controlled failure.
853 #
854 # Accepts the following options:
855 #
856 #   ok=<signal-name>[,<...>]:
857 #     Don't treat an exit caused by the given signal as error.
858 #     Multiple signals can be specified as a comma separated list.
859 #     Currently recognized signal names are: sigpipe, success.
860 #     (Don't use 'success', use 'test_might_fail' instead.)
861 #
862 # Do not use this to run anything but "git" and other specific testable
863 # commands (see test_must_fail_acceptable()).  We are not in the
864 # business of vetting system supplied commands -- in other words, this
865 # is wrong:
866 #
867 #    test_must_fail grep pattern output
868 #
869 # Instead use '!':
870 #
871 #    ! grep pattern output
872
873 test_must_fail () {
874         case "$1" in
875         ok=*)
876                 _test_ok=${1#ok=}
877                 shift
878                 ;;
879         *)
880                 _test_ok=
881                 ;;
882         esac
883         if ! test_must_fail_acceptable "$@"
884         then
885                 echo >&7 "test_must_fail: only 'git' is allowed: $*"
886                 return 1
887         fi
888         "$@" 2>&7
889         exit_code=$?
890         if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
891         then
892                 echo >&4 "test_must_fail: command succeeded: $*"
893                 return 1
894         elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
895         then
896                 return 0
897         elif test $exit_code -gt 129 && test $exit_code -le 192
898         then
899                 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
900                 return 1
901         elif test $exit_code -eq 127
902         then
903                 echo >&4 "test_must_fail: command not found: $*"
904                 return 1
905         elif test $exit_code -eq 126
906         then
907                 echo >&4 "test_must_fail: valgrind error: $*"
908                 return 1
909         fi
910         return 0
911 } 7>&2 2>&4
912
913 # Similar to test_must_fail, but tolerates success, too.  This is
914 # meant to be used in contexts like:
915 #
916 #       test_expect_success 'some command works without configuration' '
917 #               test_might_fail git config --unset all.configuration &&
918 #               do something
919 #       '
920 #
921 # Writing "git config --unset all.configuration || :" would be wrong,
922 # because we want to notice if it fails due to segv.
923 #
924 # Accepts the same options as test_must_fail.
925
926 test_might_fail () {
927         test_must_fail ok=success "$@" 2>&7
928 } 7>&2 2>&4
929
930 # Similar to test_must_fail and test_might_fail, but check that a
931 # given command exited with a given exit code. Meant to be used as:
932 #
933 #       test_expect_success 'Merge with d/f conflicts' '
934 #               test_expect_code 1 git merge "merge msg" B master
935 #       '
936
937 test_expect_code () {
938         want_code=$1
939         shift
940         "$@" 2>&7
941         exit_code=$?
942         if test $exit_code = $want_code
943         then
944                 return 0
945         fi
946
947         echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
948         return 1
949 } 7>&2 2>&4
950
951 # test_cmp is a helper function to compare actual and expected output.
952 # You can use it like:
953 #
954 #       test_expect_success 'foo works' '
955 #               echo expected >expected &&
956 #               foo >actual &&
957 #               test_cmp expected actual
958 #       '
959 #
960 # This could be written as either "cmp" or "diff -u", but:
961 # - cmp's output is not nearly as easy to read as diff -u
962 # - not all diff versions understand "-u"
963
964 test_cmp () {
965         eval "$GIT_TEST_CMP" '"$@"'
966 }
967
968 # Check that the given config key has the expected value.
969 #
970 #    test_cmp_config [-C <dir>] <expected-value>
971 #                    [<git-config-options>...] <config-key>
972 #
973 # for example to check that the value of core.bar is foo
974 #
975 #    test_cmp_config foo core.bar
976 #
977 test_cmp_config () {
978         local GD &&
979         if test "$1" = "-C"
980         then
981                 shift &&
982                 GD="-C $1" &&
983                 shift
984         fi &&
985         printf "%s\n" "$1" >expect.config &&
986         shift &&
987         git $GD config "$@" >actual.config &&
988         test_cmp expect.config actual.config
989 }
990
991 # test_cmp_bin - helper to compare binary files
992
993 test_cmp_bin () {
994         cmp "$@"
995 }
996
997 # Use this instead of test_cmp to compare files that contain expected and
998 # actual output from git commands that can be translated.  When running
999 # under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
1000 # results.
1001 test_i18ncmp () {
1002         ! test_have_prereq C_LOCALE_OUTPUT || test_cmp "$@"
1003 }
1004
1005 # Use this instead of "grep expected-string actual" to see if the
1006 # output from a git command that can be translated either contains an
1007 # expected string, or does not contain an unwanted one.  When running
1008 # under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
1009 # results.
1010 test_i18ngrep () {
1011         eval "last_arg=\${$#}"
1012
1013         test -f "$last_arg" ||
1014         BUG "test_i18ngrep requires a file to read as the last parameter"
1015
1016         if test $# -lt 2 ||
1017            { test "x!" = "x$1" && test $# -lt 3 ; }
1018         then
1019                 BUG "too few parameters to test_i18ngrep"
1020         fi
1021
1022         if test_have_prereq !C_LOCALE_OUTPUT
1023         then
1024                 # pretend success
1025                 return 0
1026         fi
1027
1028         if test "x!" = "x$1"
1029         then
1030                 shift
1031                 ! grep "$@" && return 0
1032
1033                 echo >&4 "error: '! grep $@' did find a match in:"
1034         else
1035                 grep "$@" && return 0
1036
1037                 echo >&4 "error: 'grep $@' didn't find a match in:"
1038         fi
1039
1040         if test -s "$last_arg"
1041         then
1042                 cat >&4 "$last_arg"
1043         else
1044                 echo >&4 "<File '$last_arg' is empty>"
1045         fi
1046
1047         return 1
1048 }
1049
1050 # Call any command "$@" but be more verbose about its
1051 # failure. This is handy for commands like "test" which do
1052 # not output anything when they fail.
1053 verbose () {
1054         "$@" && return 0
1055         echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
1056         return 1
1057 }
1058
1059 # Check if the file expected to be empty is indeed empty, and barfs
1060 # otherwise.
1061
1062 test_must_be_empty () {
1063         test_path_is_file "$1" &&
1064         if test -s "$1"
1065         then
1066                 echo "'$1' is not empty, it contains:"
1067                 cat "$1"
1068                 return 1
1069         fi
1070 }
1071
1072 # Tests that its two parameters refer to the same revision, or if '!' is
1073 # provided first, that its other two parameters refer to different
1074 # revisions.
1075 test_cmp_rev () {
1076         local op='=' wrong_result=different
1077
1078         if test $# -ge 1 && test "x$1" = 'x!'
1079         then
1080             op='!='
1081             wrong_result='the same'
1082             shift
1083         fi
1084         if test $# != 2
1085         then
1086                 error "bug in the test script: test_cmp_rev requires two revisions, but got $#"
1087         else
1088                 local r1 r2
1089                 r1=$(git rev-parse --verify "$1") &&
1090                 r2=$(git rev-parse --verify "$2") || return 1
1091
1092                 if ! test "$r1" "$op" "$r2"
1093                 then
1094                         cat >&4 <<-EOF
1095                         error: two revisions point to $wrong_result objects:
1096                           '$1': $r1
1097                           '$2': $r2
1098                         EOF
1099                         return 1
1100                 fi
1101         fi
1102 }
1103
1104 # Compare paths respecting core.ignoreCase
1105 test_cmp_fspath () {
1106         if test "x$1" = "x$2"
1107         then
1108                 return 0
1109         fi
1110
1111         if test true != "$(git config --get --type=bool core.ignorecase)"
1112         then
1113                 return 1
1114         fi
1115
1116         test "x$(echo "$1" | tr A-Z a-z)" =  "x$(echo "$2" | tr A-Z a-z)"
1117 }
1118
1119 # Print a sequence of integers in increasing order, either with
1120 # two arguments (start and end):
1121 #
1122 #     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
1123 #
1124 # or with one argument (end), in which case it starts counting
1125 # from 1.
1126
1127 test_seq () {
1128         case $# in
1129         1)      set 1 "$@" ;;
1130         2)      ;;
1131         *)      BUG "not 1 or 2 parameters to test_seq" ;;
1132         esac
1133         test_seq_counter__=$1
1134         while test "$test_seq_counter__" -le "$2"
1135         do
1136                 echo "$test_seq_counter__"
1137                 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
1138         done
1139 }
1140
1141 # This function can be used to schedule some commands to be run
1142 # unconditionally at the end of the test to restore sanity:
1143 #
1144 #       test_expect_success 'test core.capslock' '
1145 #               git config core.capslock true &&
1146 #               test_when_finished "git config --unset core.capslock" &&
1147 #               hello world
1148 #       '
1149 #
1150 # That would be roughly equivalent to
1151 #
1152 #       test_expect_success 'test core.capslock' '
1153 #               git config core.capslock true &&
1154 #               hello world
1155 #               git config --unset core.capslock
1156 #       '
1157 #
1158 # except that the greeting and config --unset must both succeed for
1159 # the test to pass.
1160 #
1161 # Note that under --immediate mode, no clean-up is done to help diagnose
1162 # what went wrong.
1163
1164 test_when_finished () {
1165         # We cannot detect when we are in a subshell in general, but by
1166         # doing so on Bash is better than nothing (the test will
1167         # silently pass on other shells).
1168         test "${BASH_SUBSHELL-0}" = 0 ||
1169         BUG "test_when_finished does nothing in a subshell"
1170         test_cleanup="{ $*
1171                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1172 }
1173
1174 # This function can be used to schedule some commands to be run
1175 # unconditionally at the end of the test script, e.g. to stop a daemon:
1176 #
1177 #       test_expect_success 'test git daemon' '
1178 #               git daemon &
1179 #               daemon_pid=$! &&
1180 #               test_atexit 'kill $daemon_pid' &&
1181 #               hello world
1182 #       '
1183 #
1184 # The commands will be executed before the trash directory is removed,
1185 # i.e. the atexit commands will still be able to access any pidfiles or
1186 # socket files.
1187 #
1188 # Note that these commands will be run even when a test script run
1189 # with '--immediate' fails.  Be careful with your atexit commands to
1190 # minimize any changes to the failed state.
1191
1192 test_atexit () {
1193         # We cannot detect when we are in a subshell in general, but by
1194         # doing so on Bash is better than nothing (the test will
1195         # silently pass on other shells).
1196         test "${BASH_SUBSHELL-0}" = 0 ||
1197         error "bug in test script: test_atexit does nothing in a subshell"
1198         test_atexit_cleanup="{ $*
1199                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_atexit_cleanup"
1200 }
1201
1202 # Most tests can use the created repository, but some may need to create more.
1203 # Usage: test_create_repo <directory>
1204 test_create_repo () {
1205         test "$#" = 1 ||
1206         BUG "not 1 parameter to test-create-repo"
1207         repo="$1"
1208         mkdir -p "$repo"
1209         (
1210                 cd "$repo" || error "Cannot setup test environment"
1211                 "${GIT_TEST_INSTALLED:-$GIT_EXEC_PATH}/git$X" -c \
1212                         init.defaultBranch="${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME-master}" \
1213                         init \
1214                         "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
1215                 error "cannot run git init -- have you built things yet?"
1216                 mv .git/hooks .git/hooks-disabled
1217         ) || exit
1218 }
1219
1220 # This function helps on symlink challenged file systems when it is not
1221 # important that the file system entry is a symbolic link.
1222 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
1223 # symbolic link entry y to the index.
1224
1225 test_ln_s_add () {
1226         if test_have_prereq SYMLINKS
1227         then
1228                 ln -s "$1" "$2" &&
1229                 git update-index --add "$2"
1230         else
1231                 printf '%s' "$1" >"$2" &&
1232                 ln_s_obj=$(git hash-object -w "$2") &&
1233                 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
1234                 # pick up stat info from the file
1235                 git update-index "$2"
1236         fi
1237 }
1238
1239 # This function writes out its parameters, one per line
1240 test_write_lines () {
1241         printf "%s\n" "$@"
1242 }
1243
1244 perl () {
1245         command "$PERL_PATH" "$@" 2>&7
1246 } 7>&2 2>&4
1247
1248 # Given the name of an environment variable with a bool value, normalize
1249 # its value to a 0 (true) or 1 (false or empty string) return code.
1250 #
1251 #   test_bool_env GIT_TEST_HTTPD <default-value>
1252 #
1253 # Return with code corresponding to the given default value if the variable
1254 # is unset.
1255 # Abort the test script if either the value of the variable or the default
1256 # are not valid bool values.
1257
1258 test_bool_env () {
1259         if test $# != 2
1260         then
1261                 BUG "test_bool_env requires two parameters (variable name and default value)"
1262         fi
1263
1264         git env--helper --type=bool --default="$2" --exit-code "$1"
1265         ret=$?
1266         case $ret in
1267         0|1)    # unset or valid bool value
1268                 ;;
1269         *)      # invalid bool value or something unexpected
1270                 error >&7 "test_bool_env requires bool values both for \$$1 and for the default fallback"
1271                 ;;
1272         esac
1273         return $ret
1274 }
1275
1276 # Exit the test suite, either by skipping all remaining tests or by
1277 # exiting with an error. If our prerequisite variable $1 falls back
1278 # on a default assume we were opportunistically trying to set up some
1279 # tests and we skip. If it is explicitly "true", then we report a failure.
1280 #
1281 # The error/skip message should be given by $2.
1282 #
1283 test_skip_or_die () {
1284         if ! test_bool_env "$1" false
1285         then
1286                 skip_all=$2
1287                 test_done
1288         fi
1289         error "$2"
1290 }
1291
1292 # The following mingw_* functions obey POSIX shell syntax, but are actually
1293 # bash scripts, and are meant to be used only with bash on Windows.
1294
1295 # A test_cmp function that treats LF and CRLF equal and avoids to fork
1296 # diff when possible.
1297 mingw_test_cmp () {
1298         # Read text into shell variables and compare them. If the results
1299         # are different, use regular diff to report the difference.
1300         local test_cmp_a= test_cmp_b=
1301
1302         # When text came from stdin (one argument is '-') we must feed it
1303         # to diff.
1304         local stdin_for_diff=
1305
1306         # Since it is difficult to detect the difference between an
1307         # empty input file and a failure to read the files, we go straight
1308         # to diff if one of the inputs is empty.
1309         if test -s "$1" && test -s "$2"
1310         then
1311                 # regular case: both files non-empty
1312                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1313                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1314         elif test -s "$1" && test "$2" = -
1315         then
1316                 # read 2nd file from stdin
1317                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1318                 mingw_read_file_strip_cr_ test_cmp_b
1319                 stdin_for_diff='<<<"$test_cmp_b"'
1320         elif test "$1" = - && test -s "$2"
1321         then
1322                 # read 1st file from stdin
1323                 mingw_read_file_strip_cr_ test_cmp_a
1324                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1325                 stdin_for_diff='<<<"$test_cmp_a"'
1326         fi
1327         test -n "$test_cmp_a" &&
1328         test -n "$test_cmp_b" &&
1329         test "$test_cmp_a" = "$test_cmp_b" ||
1330         eval "diff -u \"\$@\" $stdin_for_diff"
1331 }
1332
1333 # $1 is the name of the shell variable to fill in
1334 mingw_read_file_strip_cr_ () {
1335         # Read line-wise using LF as the line separator
1336         # and use IFS to strip CR.
1337         local line
1338         while :
1339         do
1340                 if IFS=$'\r' read -r -d $'\n' line
1341                 then
1342                         # good
1343                         line=$line$'\n'
1344                 else
1345                         # we get here at EOF, but also if the last line
1346                         # was not terminated by LF; in the latter case,
1347                         # some text was read
1348                         if test -z "$line"
1349                         then
1350                                 # EOF, really
1351                                 break
1352                         fi
1353                 fi
1354                 eval "$1=\$$1\$line"
1355         done
1356 }
1357
1358 # Like "env FOO=BAR some-program", but run inside a subshell, which means
1359 # it also works for shell functions (though those functions cannot impact
1360 # the environment outside of the test_env invocation).
1361 test_env () {
1362         (
1363                 while test $# -gt 0
1364                 do
1365                         case "$1" in
1366                         *=*)
1367                                 eval "${1%%=*}=\${1#*=}"
1368                                 eval "export ${1%%=*}"
1369                                 shift
1370                                 ;;
1371                         *)
1372                                 "$@" 2>&7
1373                                 exit
1374                                 ;;
1375                         esac
1376                 done
1377         )
1378 } 7>&2 2>&4
1379
1380 # Returns true if the numeric exit code in "$2" represents the expected signal
1381 # in "$1". Signals should be given numerically.
1382 test_match_signal () {
1383         if test "$2" = "$((128 + $1))"
1384         then
1385                 # POSIX
1386                 return 0
1387         elif test "$2" = "$((256 + $1))"
1388         then
1389                 # ksh
1390                 return 0
1391         fi
1392         return 1
1393 }
1394
1395 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1396 test_copy_bytes () {
1397         perl -e '
1398                 my $len = $ARGV[1];
1399                 while ($len > 0) {
1400                         my $s;
1401                         my $nread = sysread(STDIN, $s, $len);
1402                         die "cannot read: $!" unless defined($nread);
1403                         last unless $nread;
1404                         print $s;
1405                         $len -= $nread;
1406                 }
1407         ' - "$1"
1408 }
1409
1410 # run "$@" inside a non-git directory
1411 nongit () {
1412         test -d non-repo ||
1413         mkdir non-repo ||
1414         return 1
1415
1416         (
1417                 GIT_CEILING_DIRECTORIES=$(pwd) &&
1418                 export GIT_CEILING_DIRECTORIES &&
1419                 cd non-repo &&
1420                 "$@" 2>&7
1421         )
1422 } 7>&2 2>&4
1423
1424 # convert function arguments or stdin (if not arguments given) to pktline
1425 # representation. If multiple arguments are given, they are separated by
1426 # whitespace and put in a single packet. Note that data containing NULs must be
1427 # given on stdin, and that empty input becomes an empty packet, not a flush
1428 # packet (for that you can just print 0000 yourself).
1429 packetize () {
1430         if test $# -gt 0
1431         then
1432                 packet="$*"
1433                 printf '%04x%s' "$((4 + ${#packet}))" "$packet"
1434         else
1435                 perl -e '
1436                         my $packet = do { local $/; <STDIN> };
1437                         printf "%04x%s", 4 + length($packet), $packet;
1438                 '
1439         fi
1440 }
1441
1442 # Parse the input as a series of pktlines, writing the result to stdout.
1443 # Sideband markers are removed automatically, and the output is routed to
1444 # stderr if appropriate.
1445 #
1446 # NUL bytes are converted to "\\0" for ease of parsing with text tools.
1447 depacketize () {
1448         perl -e '
1449                 while (read(STDIN, $len, 4) == 4) {
1450                         if ($len eq "0000") {
1451                                 print "FLUSH\n";
1452                         } else {
1453                                 read(STDIN, $buf, hex($len) - 4);
1454                                 $buf =~ s/\0/\\0/g;
1455                                 if ($buf =~ s/^[\x2\x3]//) {
1456                                         print STDERR $buf;
1457                                 } else {
1458                                         $buf =~ s/^\x1//;
1459                                         print $buf;
1460                                 }
1461                         }
1462                 }
1463         '
1464 }
1465
1466 # Converts base-16 data into base-8. The output is given as a sequence of
1467 # escaped octals, suitable for consumption by 'printf'.
1468 hex2oct () {
1469         perl -ne 'printf "\\%03o", hex for /../g'
1470 }
1471
1472 # Set the hash algorithm in use to $1.  Only useful when testing the testsuite.
1473 test_set_hash () {
1474         test_hash_algo="$1"
1475 }
1476
1477 # Detect the hash algorithm in use.
1478 test_detect_hash () {
1479         test_hash_algo="${GIT_TEST_DEFAULT_HASH:-sha1}"
1480 }
1481
1482 # Load common hash metadata and common placeholder object IDs for use with
1483 # test_oid.
1484 test_oid_init () {
1485         test -n "$test_hash_algo" || test_detect_hash &&
1486         test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1487         test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1488 }
1489
1490 # Load key-value pairs from stdin suitable for use with test_oid.  Blank lines
1491 # and lines starting with "#" are ignored.  Keys must be shell identifier
1492 # characters.
1493 #
1494 # Examples:
1495 # rawsz sha1:20
1496 # rawsz sha256:32
1497 test_oid_cache () {
1498         local tag rest k v &&
1499
1500         { test -n "$test_hash_algo" || test_detect_hash; } &&
1501         while read tag rest
1502         do
1503                 case $tag in
1504                 \#*)
1505                         continue;;
1506                 ?*)
1507                         # non-empty
1508                         ;;
1509                 *)
1510                         # blank line
1511                         continue;;
1512                 esac &&
1513
1514                 k="${rest%:*}" &&
1515                 v="${rest#*:}" &&
1516
1517                 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1518                 then
1519                         BUG 'bad hash algorithm'
1520                 fi &&
1521                 eval "test_oid_${k}_$tag=\"\$v\""
1522         done
1523 }
1524
1525 # Look up a per-hash value based on a key ($1).  The value must have been loaded
1526 # by test_oid_init or test_oid_cache.
1527 test_oid () {
1528         local algo="${test_hash_algo}" &&
1529
1530         case "$1" in
1531         --hash=*)
1532                 algo="${1#--hash=}" &&
1533                 shift;;
1534         *)
1535                 ;;
1536         esac &&
1537
1538         local var="test_oid_${algo}_$1" &&
1539
1540         # If the variable is unset, we must be missing an entry for this
1541         # key-hash pair, so exit with an error.
1542         if eval "test -z \"\${$var+set}\""
1543         then
1544                 BUG "undefined key '$1'"
1545         fi &&
1546         eval "printf '%s' \"\${$var}\""
1547 }
1548
1549 # Insert a slash into an object ID so it can be used to reference a location
1550 # under ".git/objects".  For example, "deadbeef..." becomes "de/adbeef..".
1551 test_oid_to_path () {
1552         local basename=${1#??}
1553         echo "${1%$basename}/$basename"
1554 }
1555
1556 # Choose a port number based on the test script's number and store it in
1557 # the given variable name, unless that variable already contains a number.
1558 test_set_port () {
1559         local var=$1 port
1560
1561         if test $# -ne 1 || test -z "$var"
1562         then
1563                 BUG "test_set_port requires a variable name"
1564         fi
1565
1566         eval port=\$$var
1567         case "$port" in
1568         "")
1569                 # No port is set in the given env var, use the test
1570                 # number as port number instead.
1571                 # Remove not only the leading 't', but all leading zeros
1572                 # as well, so the arithmetic below won't (mis)interpret
1573                 # a test number like '0123' as an octal value.
1574                 port=${this_test#${this_test%%[1-9]*}}
1575                 if test "${port:-0}" -lt 1024
1576                 then
1577                         # root-only port, use a larger one instead.
1578                         port=$(($port + 10000))
1579                 fi
1580                 ;;
1581         *[!0-9]*|0*)
1582                 error >&7 "invalid port number: $port"
1583                 ;;
1584         *)
1585                 # The user has specified the port.
1586                 ;;
1587         esac
1588
1589         # Make sure that parallel '--stress' test jobs get different
1590         # ports.
1591         port=$(($port + ${GIT_TEST_STRESS_JOB_NR:-0}))
1592         eval $var=$port
1593 }
1594
1595 # Compare a file containing rev-list bitmap traversal output to its non-bitmap
1596 # counterpart. You can't just use test_cmp for this, because the two produce
1597 # subtly different output:
1598 #
1599 #   - regular output is in traversal order, whereas bitmap is split by type,
1600 #     with non-packed objects at the end
1601 #
1602 #   - regular output has a space and the pathname appended to non-commit
1603 #     objects; bitmap output omits this
1604 #
1605 # This function normalizes and compares the two. The second file should
1606 # always be the bitmap output.
1607 test_bitmap_traversal () {
1608         if test "$1" = "--no-confirm-bitmaps"
1609         then
1610                 shift
1611         elif cmp "$1" "$2"
1612         then
1613                 echo >&2 "identical raw outputs; are you sure bitmaps were used?"
1614                 return 1
1615         fi &&
1616         cut -d' ' -f1 "$1" | sort >"$1.normalized" &&
1617         sort "$2" >"$2.normalized" &&
1618         test_cmp "$1.normalized" "$2.normalized" &&
1619         rm -f "$1.normalized" "$2.normalized"
1620 }
1621
1622 # Tests for the hidden file attribute on Windows
1623 test_path_is_hidden () {
1624         test_have_prereq MINGW ||
1625         BUG "test_path_is_hidden can only be used on Windows"
1626
1627         # Use the output of `attrib`, ignore the absolute path
1628         case "$("$SYSTEMROOT"/system32/attrib "$1")" in *H*?:*) return 0;; esac
1629         return 1
1630 }
1631
1632 # Check that the given command was invoked as part of the
1633 # trace2-format trace on stdin.
1634 #
1635 #       test_subcommand [!] <command> <args>... < <trace>
1636 #
1637 # For example, to look for an invocation of "git upload-pack
1638 # /path/to/repo"
1639 #
1640 #       GIT_TRACE2_EVENT=event.log git fetch ... &&
1641 #       test_subcommand git upload-pack "$PATH" <event.log
1642 #
1643 # If the first parameter passed is !, this instead checks that
1644 # the given command was not called.
1645 #
1646 test_subcommand () {
1647         local negate=
1648         if test "$1" = "!"
1649         then
1650                 negate=t
1651                 shift
1652         fi
1653
1654         local expr=$(printf '"%s",' "$@")
1655         expr="${expr%,}"
1656
1657         if test -n "$negate"
1658         then
1659                 ! grep "\[$expr\]"
1660         else
1661                 grep "\[$expr\]"
1662         fi
1663 }